package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRLeave;
import cn.ibizlab.humanresource.core.humanresource.filter.HRLeaveSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRLeave] 服务对象接口
 */
public interface IHRLeaveService extends IService<HRLeave>{

    boolean create(HRLeave et) ;
    void createBatch(List<HRLeave> list) ;
    boolean update(HRLeave et) ;
    void updateBatch(List<HRLeave> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRLeave get(String key) ;
    HRLeave getDraft(HRLeave et) ;
    boolean checkKey(HRLeave et) ;
    boolean save(HRLeave et) ;
    void saveBatch(List<HRLeave> list) ;
    Page<HRLeave> searchDefault(HRLeaveSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRLeave> getHrleaveByIds(List<String> ids) ;
    List<HRLeave> getHrleaveByEntities(List<HRLeave> entities) ;
}


